<template>
    <split id="eqcalendarexpviewcalendarexpbar" class="app-calendar-exp-bar " v-model="split" mode="horizontal" @on-move-end="onSplitChange">
        <div slot='left'>
           <div class="container-header">
                <div class='search-container'>
                    <i-input :search="true"
                        @on-change="($event) => { this.searchText = $event.target.value; }"
                        @on-search="onSearch">
                    </i-input>
                </div>
           </div>
            <div class='calendar-exp-bar-content2'>
                <view_calendarexpbar_calendar 
    :viewState="viewState"  
    :viewparams="viewparams" 
    :context="context" 
    :showBusyIndicator="true"
    :isSelectFirstDefault="true"
    :newdata="newdata"
    :opendata="opendata"
    name="calendarexpbar_calendar"  
    ref='calendarexpbar_calendar' 
    @selectionchange="calendarexpbar_calendar_selectionchange($event)"  
    @load="calendarexpbar_calendar_load($event)"  
    @closeview="closeView($event)">
</view_calendarexpbar_calendar>
            </div>
        </div>
        <div slot='right'>
            <component 
              v-if="selection.view && !Object.is(this.selection.view.viewname, '')" 
              :is="selection.view.viewname"
              class="viewcontainer2"
              :viewDefaultUsage="false"
              :viewdata="JSON.stringify(selection.context)"
              :viewparam="JSON.stringify(selection.viewparam)">
            </component>
        </div>
    </split>
</template>


<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import EMEQAHService from '@/service/emeqah/emeqah-service';
import EqCalendarExpViewcalendarexpbarService from './eq-calendar-exp-viewcalendarexpbar-calendarexpbar-service';



@Component({
    components: {
      
    }
})
export default class EqCalendarExpViewcalendarexpbarBase extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public getControlType(): string {
        return 'CALENDAREXPBAR'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {EqCalendarExpViewcalendarexpbarService}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public service: EqCalendarExpViewcalendarexpbarService = new EqCalendarExpViewcalendarexpbarService({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMEQAHService}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public appEntityService: EMEQAHService = new EMEQAHService({ $store: this.$store });

    /**
     * calendarexpbar_calendar 部件 selectionchange 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_calendar_selectionchange($event: any, $event2?: any) {
        this.calendarexpbar_selectionchange($event, 'calendarexpbar_calendar', $event2);
    }

    /**
     * calendarexpbar_calendar 部件 load 事件
     *
     * @param {*} [args={}]
     * @param {*} $event
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_calendar_load($event: any, $event2?: any) {
        this.calendarexpbar_load($event, 'calendarexpbar_calendar', $event2);
    }
    


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }



    /**
     * 视图唯一标识
     *
     * @type {boolean}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop() public viewUID!:string;

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop() public newdata: any;
    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop() public opendata: any;

    /**
     * 是否单选
     * 
     * @public
     * @type {(boolean)}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public isSingleSelect:boolean = true;

    /**
     * 呈现模式，可选值：horizontal或者vertical
     * 
     * @public
     * @type {(string)}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public showMode:string ="horizontal";

    /**
     * 控件宽度
     *
     * @type {number}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public ctrlWidth:number = 800;

    /**
     * 控件高度
     *
     * @type {number}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public ctrlHeight: number = 0;

    /**
     * 搜素值
     * 
     * @public
     * @type {(string)}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public searchText:string = "";

    /**
     * 分割宽度
     *
     * @type {number}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public split: number = 0.5;


    /**
     * 导航视图名称
     *
     * @type {string}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public navViewName: any = {
        EMEQDEBUG: "emeqdebug-cal-edit-view9",
        EMEQKEEP: "emeqkeep-cal-edit-view9",
        EMEQMAINTANCE: "emeqmaintance-cal-edit-view9",
        EMEQSETUP: "emeqsetup-cal-edit-view9",
        EMEQCHECK: "emeqcheck-cal-edit-view9"
    };

    /**
     * 导航参数
     *
     * @type {*}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public navParam: any = {
        EMEQDEBUG: {
            navigateContext:null,
            navigateParams:null
        },
        EMEQKEEP: {
            navigateContext:null,
            navigateParams:null
        },
        EMEQMAINTANCE: {
            navigateContext:null,
            navigateParams:null
        },
        EMEQSETUP: {
            navigateContext:null,
            navigateParams:null
        },
        EMEQCHECK: {
            navigateContext:null,
            navigateParams:null
        }
    };

    /**
     * 导航过滤项
     *
     * @type {*}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public navFilter: any = {
        EMEQDEBUG: "",
        EMEQKEEP: "",
        EMEQMAINTANCE: "",
        EMEQSETUP: "",
        EMEQCHECK: ""
    };

    /**
     * 导航关系
     *
     * @type {*}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public navPSDer: any = {
        EMEQDEBUG: "",
        EMEQKEEP: "",
        EMEQMAINTANCE: "",
        EMEQSETUP: "",
        EMEQCHECK: ""
    };

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    @Prop({ default: true }) public showBusyIndicator!: boolean;


    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public getDatas(): any[] {
        return [];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public getData(): any {
        return null;
    }

    /**
     * 选中数据
     *
     * @type {*}
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public selection: any = {};

    /**
     * split值变化事件
     *
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public onSplitChange() {
        if(this.$refs.calendarexpbar_calendar){
            const calendarContainer:any = this.$refs.calendarexpbar_calendar;
            if(calendarContainer.$refs.calendar){
                const appCalendar: any = calendarContainer.$refs.calendar;
                const api = appCalendar.getApi();
                api.updateSize();
            }
        }
        if(this.split){
          this.$store.commit("setViewSplit",{viewUID:this.viewUID,viewSplit:this.split});
        }
    }

    /**
    * Vue声明周期(组件初始化完毕)
    *
    * @memberof EqCalendarExpViewcalendarexpbarBase
    */
    public created() {
         this.afterCreated();     
    }

    /**
    * 执行created后的逻辑
    *
    * @memberof EqCalendarExpViewcalendarexpbarBase
    */
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                this.viewState.next({ tag: 'calendarexpbar_calendar', action: action, data: data });
            });
        }  
    }
    
    /**
    * Vue声明周期(组件渲染完毕)
    *
    * @memberof EqCalendarExpViewcalendarexpbarBase
    */
    public mounted() {
        this.afterMounted();     
    }

    /**
    * 执行mounted后的逻辑
    *
    * @memberof EqCalendarExpViewcalendarexpbarBase
    */
    public afterMounted(){ 
        if(this.$store.getters.getViewSplit(this.viewUID)){
            this.split = this.$store.getters.getViewSplit(this.viewUID);
        }else{
            let containerWidth:number = (document.getElementById("eqcalendarexpviewcalendarexpbar") as any).offsetWidth;
            let containerHeight:number = (document.getElementById("eqcalendarexpviewcalendarexpbar") as any).offsetHeight;
            if(Object.is(this.showMode,'horizontal')){
                if(this.ctrlWidth){
                    this.split = this.ctrlWidth/containerWidth;
                }
            }else{
                if(this.ctrlHeight){
                    this.split = this.ctrlHeight/containerHeight;
                }
            }
            this.$store.commit("setViewSplit",{viewUID:this.viewUID,viewSplit:this.split}); 
        }  
    }
 
    /**
     * vue 生命周期
     *
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
    }
    
    /**
     * calendarexpbar的选中数据事件
     * 
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_selectionchange(args: any [], tag?: string, $event2?: any): void {
        let tempContext:any = {};
        let tempViewParam:any = {};
        if (args.length === 0) {
            return ;
        }
        const arg:any = args[0];
        if(this.context){
            Object.assign(tempContext,JSON.parse(JSON.stringify(this.context)));
        }
        switch(arg.itemType) {
            case "EMEQDEBUG":
                Object.assign(tempContext,{ emeqdebug : arg.emeqdebug});
                Object.assign(tempContext,{srfparentdename:'EMEQDebug',srfparentkey:arg['emeqdebug']});
                if(this.navFilter && this.navFilter['EMEQDEBUG'] && !Object.is(this.navFilter['EMEQDEBUG'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['EMEQDEBUG']]:arg['emeqdebug']});
                }
                if(this.navPSDer && this.navFilter['EMEQDEBUG'] && !Object.is(this.navPSDer['EMEQDEBUG'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['EMEQDEBUG']]:arg['emeqdebug']});
                }
                if(this.navParam && this.navParam['EMEQDEBUG'] && this.navParam['EMEQDEBUG'].navigateContext && Object.keys(this.navParam['EMEQDEBUG'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQDEBUG'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['EMEQDEBUG'] && this.navParam['EMEQDEBUG'].navigateParams && Object.keys(this.navParam['EMEQDEBUG'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQDEBUG'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
            case "EMEQKEEP":
                Object.assign(tempContext,{ emeqkeep : arg.emeqkeep});
                Object.assign(tempContext,{srfparentdename:'EMEQKeep',srfparentkey:arg['emeqkeep']});
                if(this.navFilter && this.navFilter['EMEQKEEP'] && !Object.is(this.navFilter['EMEQKEEP'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['EMEQKEEP']]:arg['emeqkeep']});
                }
                if(this.navPSDer && this.navFilter['EMEQKEEP'] && !Object.is(this.navPSDer['EMEQKEEP'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['EMEQKEEP']]:arg['emeqkeep']});
                }
                if(this.navParam && this.navParam['EMEQKEEP'] && this.navParam['EMEQKEEP'].navigateContext && Object.keys(this.navParam['EMEQKEEP'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQKEEP'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['EMEQKEEP'] && this.navParam['EMEQKEEP'].navigateParams && Object.keys(this.navParam['EMEQKEEP'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQKEEP'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
            case "EMEQMAINTANCE":
                Object.assign(tempContext,{ emeqmaintance : arg.emeqmaintance});
                Object.assign(tempContext,{srfparentdename:'EMEQMaintance',srfparentkey:arg['emeqmaintance']});
                if(this.navFilter && this.navFilter['EMEQMAINTANCE'] && !Object.is(this.navFilter['EMEQMAINTANCE'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['EMEQMAINTANCE']]:arg['emeqmaintance']});
                }
                if(this.navPSDer && this.navFilter['EMEQMAINTANCE'] && !Object.is(this.navPSDer['EMEQMAINTANCE'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['EMEQMAINTANCE']]:arg['emeqmaintance']});
                }
                if(this.navParam && this.navParam['EMEQMAINTANCE'] && this.navParam['EMEQMAINTANCE'].navigateContext && Object.keys(this.navParam['EMEQMAINTANCE'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQMAINTANCE'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['EMEQMAINTANCE'] && this.navParam['EMEQMAINTANCE'].navigateParams && Object.keys(this.navParam['EMEQMAINTANCE'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQMAINTANCE'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
            case "EMEQSETUP":
                Object.assign(tempContext,{ emeqsetup : arg.emeqsetup});
                Object.assign(tempContext,{srfparentdename:'EMEQSetup',srfparentkey:arg['emeqsetup']});
                if(this.navFilter && this.navFilter['EMEQSETUP'] && !Object.is(this.navFilter['EMEQSETUP'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['EMEQSETUP']]:arg['emeqsetup']});
                }
                if(this.navPSDer && this.navFilter['EMEQSETUP'] && !Object.is(this.navPSDer['EMEQSETUP'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['EMEQSETUP']]:arg['emeqsetup']});
                }
                if(this.navParam && this.navParam['EMEQSETUP'] && this.navParam['EMEQSETUP'].navigateContext && Object.keys(this.navParam['EMEQSETUP'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQSETUP'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['EMEQSETUP'] && this.navParam['EMEQSETUP'].navigateParams && Object.keys(this.navParam['EMEQSETUP'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQSETUP'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
            case "EMEQCHECK":
                Object.assign(tempContext,{ emeqcheck : arg.emeqcheck});
                Object.assign(tempContext,{srfparentdename:'EMEQCheck',srfparentkey:arg['emeqcheck']});
                if(this.navFilter && this.navFilter['EMEQCHECK'] && !Object.is(this.navFilter['EMEQCHECK'],"")){
                    Object.assign(tempViewParam,{[this.navFilter['EMEQCHECK']]:arg['emeqcheck']});
                }
                if(this.navPSDer && this.navFilter['EMEQCHECK'] && !Object.is(this.navPSDer['EMEQCHECK'],"")){
                    Object.assign(tempViewParam,{[this.navPSDer['EMEQCHECK']]:arg['emeqcheck']});
                }
                if(this.navParam && this.navParam['EMEQCHECK'] && this.navParam['EMEQCHECK'].navigateContext && Object.keys(this.navParam['EMEQCHECK'].navigateContext).length >0){
                    let _context:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQCHECK'].navigateContext);
                    Object.assign(tempContext,_context);
                }
                if(this.navParam && this.navParam['EMEQCHECK'] && this.navParam['EMEQCHECK'].navigateParams && Object.keys(this.navParam['EMEQCHECK'].navigateParams).length >0){
                    let _params:any = this.$util.computedNavData(arg,tempContext,tempViewParam,this.navParam['EMEQCHECK'].navigateParams);
                    Object.assign(tempViewParam,_params);
                }
                break;
        }
        this.selection = {};
        Object.assign(this.selection, { view: { viewname: this.navViewName[arg.itemType] }, context:tempContext,viewparam:tempViewParam });
        this.$emit('selectionchange',args);
        this.$forceUpdate();
    }

    /**
     * calendarexpbar的load完成事件
     * 
     * @memberof EqCalendarExpViewcalendarexpbarBase
     */
    public calendarexpbar_load(args:any, tag?: string, $event2?: any){
        this.$emit('load',args);
    }

    /**
    * 执行搜索
    *
    * @memberof EqCalendarExpViewcalendarexpbarBase
    */
    public onSearch($event:any) {
        let calendar:any = this.$refs.calendarexpbar_calendar;
        calendar.searchEvents({ query: this.searchText });
    }

}
</script>

<style lang='less'>
@import './eq-calendar-exp-viewcalendarexpbar-calendarexpbar.less';
</style>